﻿Imports onlyconnect
Public Class Form1
    Dim HtmlDoc As IHTMLDocument2
    Dim root As IHTMLElement2
    Dim Elem As IHTMLElement
    Dim TempElem As IHTMLElement2
    Dim tn() As System.Windows.Forms.TreeNode
    Dim ElemHtml As Alsing.SourceCode.SyntaxDocument
    Dim CSSListViewPropertySubItem As System.Windows.Forms.ListViewItem.ListViewSubItem = New ListViewItem.ListViewSubItem
    Dim CSSListViewValueSubItem As System.Windows.Forms.ListViewItem.ListViewSubItem = New ListViewItem.ListViewSubItem
    Dim info As ListViewHitTestInfo
    Dim ValueSelector As Object

    Private Sub ClearBackColor()
        Dim nodes As TreeNodeCollection
        nodes = TreeView.Nodes
        Dim n As TreeNode
        For Each n In nodes
            ClearRecursive(n)
        Next
    End Sub

    Private Sub ClearRecursive(ByVal treeNode As TreeNode)
        Dim tn As TreeNode
        For Each tn In treeNode.Nodes
            tn.BackColor = Color.White
            ClearRecursive(tn)
        Next
    End Sub

    Private Function GetTreeNodeFromHtml(ByVal e As IHTMLElement) As TreeNode
        Dim child As IHTMLElement
        Dim n As TreeNode = New TreeNode
        n.Text = e.tagName
        n.Tag = e
        n.Name = Trim(e.sourceIndex.ToString)
        For Each child In e.children
            n.Nodes.Add(GetTreeNodeFromHtml(child))
        Next
        Return n
    End Function

    Private Function DOMTreeInit() As Boolean
        Cursor.Current = Cursors.WaitCursor
        root = HtmlDoc.GetBody
        TreeView.Enabled = False
        TreeView.BeginUpdate()
        TreeView.Nodes.Clear()
        TreeView.Nodes.Add(GetTreeNodeFromHtml(root))
        TreeView.EndUpdate()
        TreeView.Enabled = True
        Cursor.Current = Cursors.Default
    End Function

    Private Sub HtmlEditorComponent_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles HtmlEditorComponent.MouseUp
        Dim TempElem As IHTMLElement
        ClearBackColor()
        TempElem = HtmlEditorComponent.CurrentElement
        If TreeView.Nodes.Count <> 0 Then
            tn = TreeView.Nodes.Find(TempElem.sourceIndex.ToString, True)
            TreeView.SelectedNode = tn(0)
            TreeView.SelectedNode.BackColor = Color.Yellow
        End If
    End Sub

    Private Sub HtmlEditorComponent_ReadyStateChanged(ByVal sender As Object, ByVal e As onlyconnect.ReadyStateChangedEventArgs) Handles HtmlEditorComponent.ReadyStateChanged
        ' HtmlDoc = HtmlEditorComponent.HtmlDocument2
        ' DOMTreeInit()
        ' ElemHtml = SyntaxBoxControl1.Document
        ' ElemHtml.SyntaxFile = "XML.syn"
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '  Dim Html_String As String
        ' Html_String = My.Computer.FileSystem.ReadAllText("C:\Documente\Edit_Temp.html")
        'HtmlEditorComponent.LoadDocument(Html_String)
        'HtmlEditorComponent.IsDesignMode = True
        ElemHtml = SyntaxBoxControl1.Document
        ElemHtml.SyntaxFile = "XML.syn"
    End Sub

    Private Sub TreeView_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView.AfterSelect
        ClearBackColor()
        If Not Elem Is Nothing Then
            Elem.style.SetBorderColor("")
            Elem.style.SetBorderStyle("")
            Elem.style.SetBorderWidth("")
        End If
        Elem = e.Node.Tag
        ElemHtml.Text = Elem.outerHTML
        GridViewInit(Elem)
        Elem.style.SetBorderColor("blue")
        Elem.style.SetBorderStyle("solid")
        Elem.style.SetBorderWidth("1px")
        Tempelem = HtmlEditorComponent.HtmlDocument2.GetActiveElement
        If Elem.offsetTop - Tempelem.GetScrollTop > HtmlEditorComponent.Height - 50 Or Elem.offsetTop - Tempelem.GetScrollTop < 0 Then Elem.scrollIntoView()
    End Sub

    Private Function GridViewInit(ByVal GridViewElement As IHTMLElement) As Boolean
        Dim RulesCollection() As String
        Dim Rules() As String
        Dim CSSText As String
        Dim Pos As Integer
        Dim i As Integer
        ListViewEx1.Items.Clear()
        CSSText = GridViewElement.style.GetCssText
        If Not CSSText Is Nothing Then
            RulesCollection = Split(CSSText, ";")
            ReDim Rules(RulesCollection.Length - 1)
            For i = 0 To RulesCollection.Length - 1
                Rules(i) = RulesCollection(i)
                Pos = InStr(Rules(i), ":")
                Dim CSSListViewItem As ListViewItem = New ListViewItem()
                CSSListViewItem.Text = Trim(Mid(Rules(i), 1, Pos - 1))
                CSSListViewItem.SubItems.Add(Trim(Mid(Rules(i), Pos + 1, Rules(i).Length)))
                ListViewEx1.Items.Add(CSSListViewItem)
            Next
        End If
    End Function

    Private Sub SaveCssStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveCssStripButton.Click
        Dim CSSText As String
        Dim RowText(2) As String
        Dim i As Integer
        ClearBackColor()
        CSSText = ""
        For i = 0 To ListViewEx1.Items.Count - 1
            RowText(0) = ListViewEx1.Items(i).Text
            RowText(1) = ListViewEx1.Items(i).SubItems(1).Text
            CSSText = CSSText & RowText(0) & ":" & RowText(1) & "; "
        Next
        Elem.style.SetCssText(CSSText)
        ElemHtml.Text = Elem.outerHTML
    End Sub

    Private Sub ListViewEx1_SubItemClicked(ByVal sender As Object, ByVal e As ListViewExtended.SubItemEventArgs) Handles ListViewEx1.SubItemClicked
        Dim ControlObject As Object
        If e.SubItem = 0 Then
            ComboBox1.Items.Clear()
            Dim PropertyArray As Array = CSSProperties()
            For Each value As String In PropertyArray
                ComboBox1.Items.Add(value)
            Next
            ListViewEx1.StartEditing(ComboBox1, e.Item, e.SubItem)
        Else

            ControlObject = ControlSelection(e.Item.Text, e.Item.SubItems(1).Text)
            ListViewEx1.StartEditing(ControlObject, e.Item, e.SubItem)
        End If
    End Sub
    
    Private Sub LoadHtmlFileToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadHtmlFileToolStripButton.Click
        If TreeView.Nodes.Count <> 0 Then
            TreeView.Nodes.Remove(TreeView.Nodes.Item(0))
        End If
        OpenFileDialog1.Filter = "HTML .htm files|*.htm*|All Files|*.*"
        Dim Html_String_File As String
        Dim Html_String As String
        'Html_String = My.Computer.FileSystem.ReadAllText("C:\Documente\Edit_Temp.html")
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            Html_String_File = OpenFileDialog1.FileName
        Else : Exit Sub
        End If
        HtmlEditorComponent.IsDesignMode = True
        Html_String = My.Computer.FileSystem.ReadAllText(Html_String_File)
        HtmlEditorComponent.LoadDocument(Html_String)
        While Not HtmlEditorComponent.ReadyState = "complete"
            My.Application.DoEvents()
        End While
        HtmlDoc = HtmlEditorComponent.HtmlDocument2
        DOMTreeInit()
    End Sub

    Private Sub SaveAsStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsStripButton.Click
        HtmlEditorComponent.SaveAs("test")
    End Sub
End Class
