﻿Imports System.Text.RegularExpressions
Module ListViewFunctions

    Public Function CSSProperties() As Array
        Dim CSSPropertiesArray() As String
        CSSPropertiesArray = New String() {"ALIGN", "BACKGROUND-COLOR", "BORDER", "BORDER-COLOR", _
"BORDER-STYLE", "BORDER-WIDTH", "CLEAR", "COLOR", "DISPLAY", "FLOAT", "FONT-FAMILY", "FONT-SIZE", _
 "FONT-STYLE", "FONT-WEIGHT", "HEIGHT", "LINE-HEIGHT", "LIST-STYLE-TYPE", "MARGIN-BOTTOM", _
 "MARGIN-LEFT", "MARGIN-RIGHT", "MARGIN-TOP", "OEB-COLUMN-NUMBER", "PAGE-BREACK-BEFORE", _
 "PAGE-BREAK-INSIDE", "TEXT-ALIGN", "TEXT-DECORATION", "TEXT-INDENT", "WIDTH"}
        Return CSSPropertiesArray
    End Function

    Public Function CSSValuesSelection(ByVal CSSProperty As String, Optional ByVal CSSValue As String = "") As Array
        Dim CSSValues() As String
        Select Case CSSProperty
            Case "ALIGN"
                CSSValues = New String() {"top", "middle", "bottom"}
            Case "BACKGROUND-COLOR"
                CSSValues = New String() {""}
            Case "BORDER"
                CSSValues = New String() {"none", "solid"}
            Case "BORDER-COLOR"
                CSSValues = New String() {""}
            Case "BORDER-STYLE"
                CSSValues = New String() {"dotted", "dashed", "double", "groove", "ridge", "inset", "outset"}
            Case "BORDER-WIDTH"
                CSSValues = New String() {"thin", "medium", "thick"}
            Case "CLEAR"
                CSSValues = New String() {"none", "left", "right", "both"}
            Case "COLOR"
                CSSValues = New String() {""}
            Case "DISPLAY"
                CSSValues = New String() {"block", "inline", "list-item", "oeb-page-head", _
                "oeb-page-foot", "none"}
            Case "FLOAT"
                CSSValues = New String() {"left", "right", "none"}
            Case "FONT-FAMILY"
                CSSValues = New String() {"serif", "sans-serif", "monospace", "small"}
            Case "FONT-SIZE"
                CSSValues = New String() {"xx-small", "x-small", "small", "medium", "large", _
                                         "x-large", "xx-large", "smaller", "larger"}
            Case "FONT-STYLE"
                CSSValues = New String() {"normal", "italic"}
            Case "FONT-WEIGHT"
                CSSValues = New String() {"normal", "bold"}
            Case "HEIGHT"
                CSSValues = New String() {""}
            Case "LINE-HEIGHT"
                CSSValues = New String() {""}
            Case "LIST-STYLE-TYPE"
                CSSValues = New String() {"decimal", "lower-roman", "upper-roman", "lower-alpha", _
                    "upper-alpha"}
            Case "MARGIN-BOTTOM"
                CSSValues = New String() {""}
            Case "MARGIN-LEFT"
                CSSValues = New String() {""}
            Case "MARGIN-RIGHT"
                CSSValues = New String() {""}
            Case "MARGIN-TOP"
                CSSValues = New String() {""}
            Case "OEB-COLUMN-NUMBER"
                CSSValues = New String() {"auto", "1"}
            Case "PAGE-BREAK-BEFORE"
                CSSValues = New String() {"auto", "always", "left", "right"}
            Case "PAGE-BREAK-INSIDE"
                CSSValues = New String() {"auto", "avoid"}
            Case "TEXT-ALIGN"
                CSSValues = New String() {"left", "right", "center", "justify"}
            Case "TEXT-DECORATION"
                CSSValues = New String() {"none", "underline", "line-through"}
            Case "TEXT-INDENT"
                CSSValues = New String() {""}
            Case "WIDTH"
                CSSValues = New String() {""}
            Case Else
                CSSValues = New String() {""}
        End Select
        Return CSSValues
    End Function

    Public Function ControlSelection(ByVal ActualCSSProperty As String, ByVal ActualCSSValue As String) As Object
        Dim ValueArray As Array
        Select Case ActualCSSProperty
            Case "ALIGN", "BORDER", "BORDER-STYLE", "BORDER-WIDTH", "CLEAR", "DISPLAY", "FLOAT", _
            "FONT-FAMILY", "FONT-SIZE", "FONT-STYLE", "FONT-WEIGHT", "LIST-STYLE-TYPE", _
            "OEB-COLUMN-NUMBER", "PAGE-BREAK-BEFORE", "PAGE-BREAK-INSIDE", _
            "TEXT-ALIGN", "TEXT-DECORATION"
                Form1.ComboBox1.Items.Clear()
                ValueArray = CSSValuesSelection(ActualCSSProperty)
                For Each value As String In ValueArray
                    Form1.ComboBox1.Items.Add(value)
                Next
                Return Form1.ComboBox1
            Case "HEIGHT", "LINE-HEIGHT", "MARGIN-BOTTOM", "MARGIN-LEFT", "MARGIN-RIGHT", _
            "MARGIN-TOP", "TEXT-INDENT", "WIDTH"
                Form1.DomainUpDown1.Items.Clear()
                Dim index As Integer
                Dim ValueNumeric As MatchCollection = Regex.Matches(ActualCSSValue, "\d{1,3}", RegexOptions.None)
                Dim ValueUnit As MatchCollection = Regex.Matches(ActualCSSValue, "\D{1,2}", RegexOptions.None)
                For index = 0 To 99
                    Form1.DomainUpDown1.Items.Add(index.ToString + ValueUnit.Item(0).ToString)
                Next
                Form1.DomainUpDown1.SelectedIndex = Val(ValueNumeric.Item(0).ToString)
                Return Form1.DomainUpDown1
            Case "BACKGROUND-COLOR", "BORDER-COLOR", "COLOR"
                Return Form1.TextBox1
        End Select
        Return Nothing
    End Function
End Module

